#include "AL.h"
#include <stdlib.h>

AL alMk(){
  AL this;
  this.capacity = 5;
  this.size = 0;
  this.store = malloc(this.capacity*sizeof(Object));
  return this;
}

void alDelete(AL* this){
  free(this->store);
}

void enlargeStore(AL* this){
  this->capacity += 5;
  Object* newStore = malloc(sizeof(Object)*(this->capacity));
  int i;
  for (i=0; i<this->size;i++){
    newStore[i] = this->store[i];
  }
  free(this->store);
  this->store = newStore;
}
void alAdd(AL* this, Object o){
  if (this->size>=this->capacity) enlargeStore(this);
  this->store[this->size++] = o;
}


void alForEach(AL* this,Consumer action){
  int i;
  for (i=0;i<this->size;i++){
    action(this->store[i]);
  }
}
